
typedef struct scope {
	struct scope *outer;
	hash_t *hash;
	FILE *file;
	char *filename;
	int lineno;
	int nargs;
	char **args;
	int ifdepth;
} scope_t;

void	scope_undefine(scope_t *, char *);
int	scope_define(scope_t *, char *, char *);
char	*scope_lookup(scope_t *, char *);
scope_t	*new_scope(void);
void	free_scope(scope_t *);
